/*----------------------------------------------------------------------------*/
/* Teknisa Sistemas Integrados                                                */
/* 6704_ORESTPO_GERA_COMPOSICAO_RETIRADA.SQL                                  */
/* Autor: Diego Gonalves                                                     */
/* Data: 26/01/2010                                                           */
/* Descrio:                                                                 */
/*    Insere os produtos da composio na tabela ITEMRETIORE de               */
/*  acordo com os parmetros usados na tela Parmetros para Matria Prima     */
/*----------------------------------------------------------------------------*/
CREATE or REPLACE
PROCEDURE GERA_COMPOSICAO_RETIRADA ( P_CDFILIAL        IN VARCHAR2,
                                     P_NRRETIRADAORE   IN VARCHAR2,
                                     P_NRITEMRETIORE   IN VARCHAR2,
                                     P_CDPRODUTO       IN VARCHAR2,
                                     P_QTITEMPED       IN DOUBLE PRECISION,
                                     P_DTATUAL         IN DATE,
                                     P_IDTIPENTSAID    IN VARCHAR2,
                                     P_CDOPERADOR      IN VARCHAR2,
                                     P_NRPEDIDO        IN VARCHAR2,
                                     P_NRITEMPED       IN VARCHAR2,
                                     P_IDTIPORETIORE   IN VARCHAR2 DEFAULT '',
                                     P_CDPRODORIGITRET IN VARCHAR2 DEFAULT '')
AS
   V_NRITEMRETIORE  VARCHAR2(5);
   V_IDTIPORETIORE  VARCHAR2(1);
   V_COTLOCAL       DOUBLE PRECISION;
   V_COTPADRAO      DOUBLE PRECISION;
   V_VERIFITEMRETI  DOUBLE PRECISION;
   V_QTCOMPPROD     DOUBLE PRECISION;
BEGIN

   V_NRITEMRETIORE := '';

   SELECT LPAD((NVL(MAX(NRITEMRETIORE), 0) + 1), 5, 0)
     INTO V_NRITEMRETIORE
     FROM ITEMRETIORE
    WHERE CDFILIAL      = P_CDFILIAL
      AND NRRETIRADAORE = P_NRRETIRADAORE;


   SELECT IDTIPORETIORE
     INTO V_IDTIPORETIORE
     FROM PRODUTO
    WHERE CDPRODUTO = P_CDPRODUTO;

    V_IDTIPORETIORE := NVL(P_IDTIPORETIORE, V_IDTIPORETIORE);

   IF V_IDTIPORETIORE = 'C' THEN
   /*Grava o produto da composio na tabela ITEMRETIORE*/
      SELECT COUNT(*)
        INTO V_COTLOCAL
        FROM ROTFABLOCAL R
       WHERE (R.CDFILIAL  = P_CDFILIAL   )
         AND (R.CDPRODUTO = P_CDPRODUTO );

      IF V_COTLOCAL > 0 THEN
         /* Composio Local */
         FOR C_COMPLOCAL IN (SELECT R.CDPRODUTO, R.CDSUBPRODLOC, R.QTSUBPRODLOC
                               FROM ROTFABLOCAL R
                              WHERE (R.CDFILIAL  = P_CDFILIAL   )
                                AND (R.CDPRODUTO = P_CDPRODUTO )
                              ORDER BY R.NRSEQPRODLOC)LOOP

            V_QTCOMPPROD := (C_COMPLOCAL.QTSUBPRODLOC * P_QTITEMPED);
            GERA_COMPOSICAO_RETIRADA ( P_CDFILIAL, P_NRRETIRADAORE, V_NRITEMRETIORE,
                                       C_COMPLOCAL.CDSUBPRODLOC, V_QTCOMPPROD,
                                       P_DTATUAL, P_IDTIPENTSAID, P_CDOPERADOR, P_NRPEDIDO, P_NRITEMPED, '', P_CDPRODORIGITRET);

         END LOOP;
      ELSE
         SELECT COUNT(*)
           INTO V_COTPADRAO
           FROM ROTFABRICA R
          WHERE (R.CDPRODUTO    = P_CDPRODUTO);

         IF V_COTPADRAO > 0 THEN
            /*Composio Padro*/
            FOR C_COMPPADRAO IN (SELECT R.CDPRODUTO, R.CDSUBPRODUTO, R.QTSUBPRODROT
                                   FROM ROTFABRICA R
                                  WHERE (R.CDPRODUTO    = P_CDPRODUTO)
                                  ORDER BY R.CDPRODUTO)LOOP

               V_QTCOMPPROD := (C_COMPPADRAO.QTSUBPRODROT * P_QTITEMPED);
               GERA_COMPOSICAO_RETIRADA ( P_CDFILIAL, P_NRRETIRADAORE, V_NRITEMRETIORE,
                                          C_COMPPADRAO.CDSUBPRODUTO, V_QTCOMPPROD,
                                          P_DTATUAL, P_IDTIPENTSAID, P_CDOPERADOR, P_NRPEDIDO, P_NRITEMPED, '', P_CDPRODORIGITRET);
            END LOOP;
         ELSE
            /*Verifica se o item ja est na tabela ITEMRETIORE*/
            SELECT NVL(COUNT(*), 0)
              INTO V_VERIFITEMRETI
              FROM ITEMRETIORE
             WHERE CDFILIALPED     = P_CDFILIAL
               AND NRPEDIDO        = P_NRPEDIDO
               AND NRITEMPED       = P_NRITEMPED
               AND CDPRODUTO       = P_CDPRODUTO
               AND IDLANCRETIORE   = P_IDTIPENTSAID;

            IF V_VERIFITEMRETI = 0 THEN
               INSERT INTO ITEMRETIORE
                  (CDFILIAL, NRRETIRADAORE, NRITEMRETIORE, CDPRODUTO, QTPREVITRETIORE,
                   QTMOVIITRETIORE, DTMOVIITRETIORE, IDLANCRETIORE, CDOPERADOR, CDFILIALPED, NRPEDIDO, NRITEMPED, CDPRODORIGITRET)
               VALUES
                  (P_CDFILIAL , P_NRRETIRADAORE, V_NRITEMRETIORE, P_CDPRODUTO, P_QTITEMPED,
                   P_QTITEMPED, P_DTATUAL, P_IDTIPENTSAID, P_CDOPERADOR, P_CDFILIAL, P_NRPEDIDO, P_NRITEMPED, P_CDPRODORIGITRET);
            END IF;
         END IF;
      END IF;
   ELSE
      /*Grava o produto acabado direto na tabela ITEMRETIORE*/
      SELECT NVL(COUNT(*), 0)
        INTO V_VERIFITEMRETI
        FROM ITEMRETIORE
       WHERE CDFILIALPED   = P_CDFILIAL
         AND NRPEDIDO      = P_NRPEDIDO
         AND NRITEMPED     = P_NRITEMPED
         AND CDPRODUTO     = P_CDPRODUTO
         AND IDLANCRETIORE = P_IDTIPENTSAID;

      IF V_VERIFITEMRETI = 0 THEN
         INSERT INTO ITEMRETIORE
            (CDFILIAL, NRRETIRADAORE, NRITEMRETIORE, CDPRODUTO, QTPREVITRETIORE,
             QTMOVIITRETIORE, DTMOVIITRETIORE, IDLANCRETIORE, CDOPERADOR, CDFILIALPED, NRPEDIDO, NRITEMPED, CDPRODORIGITRET)
         VALUES
            (P_CDFILIAL , P_NRRETIRADAORE, V_NRITEMRETIORE, P_CDPRODUTO, P_QTITEMPED,
             P_QTITEMPED, P_DTATUAL, P_IDTIPENTSAID, P_CDOPERADOR, P_CDFILIAL, P_NRPEDIDO, P_NRITEMPED, P_CDPRODORIGITRET);
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_COMPOSICAO_RETIRADA','5.09.014'); END;
/